This service will be undergoing maintenance at 00:00 UTC, 2017-10-23 It is expected to last about 30 minutes
Bug 1266864 - (6.0.x) cxf.xml works in community, not in product (SwitchYard)
(6.0.x) cxf.xml works in community, not in product (SwitchYard)
Status: VERIFIED
Product: JBoss Fuse Service Works 6
Classification: JBoss
Component: SwitchYard (Show other bugs)
6.0.0 GA
Unspecified Unspecified
high Severity high
: CR1
: ---
Assigned To: tcunning
Matej Melko
:
Depends On:
Blocks: 1214695
  Show dependency treegraph
 
Reported: 2015-09-28 05:27 EDT by Tadayoshi Sato
Modified: 2016-03-30 08:55 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: Support Patch
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
http-redirect.zip (18.38 KB, application/zip)
2015-09-28 05:29 EDT, Tadayoshi Sato
no flags Details
ws-security.zip (16.92 KB, application/zip)
2015-09-28 05:31 EDT, Tadayoshi Sato
no flags Details


External Trackers
Tracker ID Priority Status Summary Last Updated
JBoss Issue Tracker ENTESB-4015 Major Resolved [FSW 6.0.x] cxf.xml works in community, not in product (SwitchYard) 2016-05-19 06:52 EDT

  None (edit)
Description Tadayoshi Sato 2015-09-28 05:27:29 EDT
Cloned from https://issues.jboss.org/browse/ENTESB-4015 for FSW 6.0 roll-up patch.
==================================================================================
The cxf.xml support doesn't work on FSW 6.0.5 (FSW_6.0_1_2015), which is supposed to have this support already (BZ-1191864).

When deploying the attached 'http-redirect' project, the deployment fails with the following error:
-----
10:19:24,549 ERROR [org.jboss.msc.service.fail] (MSC service thread 1-16) MSC000001: Failed to start service jboss.deployment.unit."samples-switchyard-http-redirect-sy-2.0.jar".SwitchYardService: org.jboss.msc.service.StartException in service jboss.deployment.unit."samples-switchyard-http-redirect-sy-2.0.jar".SwitchYardService: Failed to start service
	at org.jboss.msc.service.ServiceControllerImpl$StartTask.run(ServiceControllerImpl.java:1767) [jboss-msc-1.0.4.GA-redhat-1.jar:1.0.4.GA-redhat-1]
	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1145) [rt.jar:1.7.0_79]
	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:615) [rt.jar:1.7.0_79]
	at java.lang.Thread.run(Thread.java:745) [rt.jar:1.7.0_79]
Caused by: java.lang.IncompatibleClassChangeError: class org.springframework.core.LocalVariableTableParameterNameDiscoverer$ParameterNameDiscoveringVisitor has interface org.springframework.asm.ClassVisitor as super class
	at java.lang.ClassLoader.defineClass1(Native Method) [rt.jar:1.7.0_79]
	at java.lang.ClassLoader.defineClass(ClassLoader.java:800) [rt.jar:1.7.0_79]
	at org.jboss.modules.ModuleClassLoader.doDefineOrLoadClass(ModuleClassLoader.java:361) [jboss-modules.jar:1.3.3.Final-redhat-1]
	at org.jboss.modules.ModuleClassLoader.defineClass(ModuleClassLoader.java:482) [jboss-modules.jar:1.3.3.Final-redhat-1]
	at org.jboss.modules.ModuleClassLoader.loadClassLocal(ModuleClassLoader.java:277) [jboss-modules.jar:1.3.3.Final-redhat-1]
	at org.jboss.modules.ModuleClassLoader$1.loadClassLocal(ModuleClassLoader.java:92) [jboss-modules.jar:1.3.3.Final-redhat-1]
	at org.jboss.modules.Module.loadModuleClass(Module.java:568) [jboss-modules.jar:1.3.3.Final-redhat-1]
	at org.jboss.modules.ModuleClassLoader.findClass(ModuleClassLoader.java:205) [jboss-modules.jar:1.3.3.Final-redhat-1]
	at org.jboss.modules.ConcurrentClassLoader.performLoadClassUnchecked(ConcurrentClassLoader.java:459) [jboss-modules.jar:1.3.3.Final-redhat-1]
	at org.jboss.modules.ConcurrentClassLoader.performLoadClassChecked(ConcurrentClassLoader.java:408) [jboss-modules.jar:1.3.3.Final-redhat-1]
	at org.jboss.modules.ConcurrentClassLoader.performLoadClass(ConcurrentClassLoader.java:389) [jboss-modules.jar:1.3.3.Final-redhat-1]
	at org.jboss.modules.ConcurrentClassLoader.loadClass(ConcurrentClassLoader.java:134) [jboss-modules.jar:1.3.3.Final-redhat-1]
	at org.springframework.core.LocalVariableTableParameterNameDiscoverer.inspectClass(LocalVariableTableParameterNameDiscoverer.java:112)
	at org.springframework.core.LocalVariableTableParameterNameDiscoverer.getParameterNames(LocalVariableTableParameterNameDiscoverer.java:72)
	at org.springframework.beans.factory.support.ConstructorResolver.instantiateUsingFactoryMethod(ConstructorResolver.java:467)
	at org.springframework.beans.factory.support.AbstractAutowireCapableBeanFactory.instantiateUsingFactoryMethod(AbstractAutowireCapableBeanFactory.java:1057)
	at org.springframework.beans.factory.support.AbstractAutowireCapableBeanFactory.createBeanInstance(AbstractAutowireCapableBeanFactory.java:953)
	at org.springframework.beans.factory.support.AbstractAutowireCapableBeanFactory.doCreateBean(AbstractAutowireCapableBeanFactory.java:487)
	at org.springframework.beans.factory.support.AbstractAutowireCapableBeanFactory.createBean(AbstractAutowireCapableBeanFactory.java:458)
	at org.springframework.beans.factory.support.BeanDefinitionValueResolver.resolveInnerBean(BeanDefinitionValueResolver.java:276)
	at org.springframework.beans.factory.support.BeanDefinitionValueResolver.resolveValueIfNecessary(BeanDefinitionValueResolver.java:129)
	at org.springframework.beans.factory.support.AbstractAutowireCapableBeanFactory.applyPropertyValues(AbstractAutowireCapableBeanFactory.java:1419)
	at org.springframework.beans.factory.support.AbstractAutowireCapableBeanFactory.populateBean(AbstractAutowireCapableBeanFactory.java:1160)
	at org.springframework.beans.factory.support.AbstractAutowireCapableBeanFactory.configureBean(AbstractAutowireCapableBeanFactory.java:319)
	at org.springframework.beans.factory.wiring.BeanConfigurerSupport.configureBean(BeanConfigurerSupport.java:144)
	at org.apache.cxf.configuration.spring.ConfigurerImpl.configureBean(ConfigurerImpl.java:170)
	at org.apache.cxf.configuration.spring.ConfigurerImpl.configureBean(ConfigurerImpl.java:128)
	at org.jboss.wsf.stack.cxf.client.configuration.JBossWSSpringConfigurer.configureBean(JBossWSSpringConfigurer.java:60)
	at org.apache.cxf.transport.http.HTTPTransportFactory.configure(HTTPTransportFactory.java:186)
	at org.apache.cxf.transport.http.HTTPTransportFactory.getConduit(HTTPTransportFactory.java:260)
	at org.apache.cxf.binding.soap.SoapTransportFactory.getConduit(SoapTransportFactory.java:227)
	at org.apache.cxf.binding.soap.SoapTransportFactory.getConduit(SoapTransportFactory.java:234)
	at org.apache.cxf.endpoint.AbstractConduitSelector.getSelectedConduit(AbstractConduitSelector.java:103)
	at org.apache.cxf.endpoint.UpfrontConduitSelector.selectConduit(UpfrontConduitSelector.java:77)
	at org.apache.cxf.endpoint.ClientImpl.getConduit(ClientImpl.java:846)
	at org.switchyard.component.soap.OutboundHandler.doStart(OutboundHandler.java:155)
	at org.switchyard.deploy.BaseServiceHandler.start(BaseServiceHandler.java:60)
	at org.switchyard.deploy.internal.Deployment.deployReferenceBindings(Deployment.java:310)
	at org.switchyard.deploy.internal.Deployment.start(Deployment.java:143)
	at org.switchyard.as7.extension.deployment.SwitchYardDeployment.start(SwitchYardDeployment.java:127)
	at org.switchyard.as7.extension.services.SwitchYardService.start(SwitchYardService.java:77)
	at org.jboss.msc.service.ServiceControllerImpl$StartTask.startService(ServiceControllerImpl.java:1811) [jboss-msc-1.0.4.GA-redhat-1.jar:1.0.4.GA-redhat-1]
	at org.jboss.msc.service.ServiceControllerImpl$StartTask.run(ServiceControllerImpl.java:1746) [jboss-msc-1.0.4.GA-redhat-1.jar:1.0.4.GA-redhat-1]
	... 3 more
-----


In turn, when deploying the other attached 'ws-security' project, the deployment fails with the following error:
-----
18:07:09,486 ERROR [org.jboss.msc.service.fail] (MSC service thread 1-3) MSC000001: Failed to start service jboss.deployment.unit."samples-switchyard-ws-security-2.0.jar".SwitchYardService: org.jboss.msc.service.StartException in service jboss.deployment.unit."samples-switchyard-ws-security-2.0.jar".SwitchYardService: Failed to start service
	at org.jboss.msc.service.ServiceControllerImpl$StartTask.run(ServiceControllerImpl.java:1767) [jboss-msc-1.0.4.GA-redhat-1.jar:1.0.4.GA-redhat-1]
	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1145) [rt.jar:1.7.0_79]
	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:615) [rt.jar:1.7.0_79]
	at java.lang.Thread.run(Thread.java:745) [rt.jar:1.7.0_79]
Caused by: java.lang.NoSuchFieldError: NULL
	at org.springframework.expression.TypedValue.<clinit>(TypedValue.java:32)
	at org.springframework.expression.spel.support.StandardEvaluationContext.setRootObject(StandardEvaluationContext.java:88)
	at org.springframework.expression.spel.support.StandardEvaluationContext.<init>(StandardEvaluationContext.java:74)
	at org.springframework.context.expression.StandardBeanExpressionResolver.evaluate(StandardBeanExpressionResolver.java:124)
	at org.springframework.beans.factory.support.AbstractBeanFactory.evaluateBeanDefinitionString(AbstractBeanFactory.java:1315)
	at org.springframework.beans.factory.support.BeanDefinitionValueResolver.evaluate(BeanDefinitionValueResolver.java:214)
	at org.springframework.beans.factory.support.BeanDefinitionValueResolver.resolveValueIfNecessary(BeanDefinitionValueResolver.java:186)
	at org.springframework.beans.factory.support.BeanDefinitionValueResolver.resolveManagedMap(BeanDefinitionValueResolver.java:383)
	at org.springframework.beans.factory.support.BeanDefinitionValueResolver.resolveValueIfNecessary(BeanDefinitionValueResolver.java:165)
	at org.springframework.beans.factory.support.AbstractAutowireCapableBeanFactory.applyPropertyValues(AbstractAutowireCapableBeanFactory.java:1419)
	at org.springframework.beans.factory.support.AbstractAutowireCapableBeanFactory.populateBean(AbstractAutowireCapableBeanFactory.java:1160)
	at org.springframework.beans.factory.support.AbstractAutowireCapableBeanFactory.configureBean(AbstractAutowireCapableBeanFactory.java:319)
	at org.springframework.beans.factory.wiring.BeanConfigurerSupport.configureBean(BeanConfigurerSupport.java:144)
	at org.apache.cxf.configuration.spring.ConfigurerImpl.configureBean(ConfigurerImpl.java:170)
	at org.apache.cxf.configuration.spring.ConfigurerImpl.configureBean(ConfigurerImpl.java:128)
	at org.jboss.wsf.stack.cxf.client.configuration.JBossWSSpringConfigurer.configureBean(JBossWSSpringConfigurer.java:60)
	at org.apache.cxf.jaxws.ServiceImpl.configureObject(ServiceImpl.java:544)
	at org.apache.cxf.jaxws.ServiceImpl.createDispatch(ServiceImpl.java:615)
	at org.apache.cxf.jaxws.ServiceImpl.createDispatch(ServiceImpl.java:604)
	at javax.xml.ws.Service.createDispatch(Service.java:368) [rt.jar:1.7.0_79]
	at org.switchyard.component.soap.OutboundHandler.doStart(OutboundHandler.java:128)
	at org.switchyard.deploy.BaseServiceHandler.start(BaseServiceHandler.java:60)
	at org.switchyard.deploy.internal.Deployment.deployReferenceBindings(Deployment.java:310)
	at org.switchyard.deploy.internal.Deployment.start(Deployment.java:143)
	at org.switchyard.as7.extension.deployment.SwitchYardDeployment.start(SwitchYardDeployment.java:127)
	at org.switchyard.as7.extension.services.SwitchYardService.start(SwitchYardService.java:77)
	at org.jboss.msc.service.ServiceControllerImpl$StartTask.startService(ServiceControllerImpl.java:1811) [jboss-msc-1.0.4.GA-redhat-1.jar:1.0.4.GA-redhat-1]
	at org.jboss.msc.service.ServiceControllerImpl$StartTask.run(ServiceControllerImpl.java:1746) [jboss-msc-1.0.4.GA-redhat-1.jar:1.0.4.GA-redhat-1]
	... 3 more
-----

The fix needs to resolve all those issues.
Comment 1 Tadayoshi Sato 2015-09-28 05:29 EDT
Created attachment 1077903 [details]
http-redirect.zip
Comment 2 Tadayoshi Sato 2015-09-28 05:31 EDT
Created attachment 1077904 [details]
ws-security.zip
Comment 3 Tadayoshi Sato 2015-09-28 05:31:57 EDT
The following fix seems to resolve all the deployment problems:

* Add {{$FSW_HOME/modules/system/layers/soa/org/springframework/main/spring-expression-3.2.12.RELEASE.jar}}
* Change {{$FSW_HOME/modules/system/layers/soa/org/springframework/main/module.xml}} as follows:
-----
<module xmlns="urn:jboss:module:1.0" name="org.springframework">

    <resources>
        <resource-root path="spring-aop-3.2.12.RELEASE.jar"/>
        <!-- resource-root path="spring-asm-3.0.7.RELEASE.jar"/ -->
        <resource-root path="spring-beans-3.2.12.RELEASE.jar"/>
        <resource-root path="spring-core-3.2.12.RELEASE.jar"/>
        <resource-root path="spring-context-3.2.12.RELEASE.jar"/>
        <resource-root path="spring-expression-3.2.12.RELEASE.jar"/>
        <resource-root path="spring-jms-3.2.12.RELEASE.jar"/>
        <resource-root path="spring-jdbc-3.2.12.RELEASE.jar"/>
        <resource-root path="spring-tx-3.2.12.RELEASE.jar"/>
        <resource-root path="spring-orm-3.2.12.RELEASE.jar"/>
        <resource-root path="spring-jdbc-3.2.12.RELEASE.jar"/>
    </resources>

    <dependencies>
        <module name="org.apache.commons.logging"/>
        <module name="javax.persistence.api"/>
        <module name="javax.jms.api"/>
        <module name="javax.api"/>
    </dependencies>
</module>
-----

Note You need to log in before you can comment on or make changes to this bug.